2017 icpc beijing J/HihoCoder 1636 Pangu and Stones【区间dp】

 Pangu and Stones

Time Limit:1000ms

Case Time Limit:1000ms

Memory Limit:256MB

Description

In Chinese mythology, Pangu is the first living being and the creator of the sky and the earth. He woke up from an egg and split the egg into two parts: the sky and the earth.

At the beginning, there was no mountain on the earth, only stones all over the land.

There were N piles of stones, numbered from 1 to N. Pangu wanted to merge all of them into one pile to build a great mountain. If the sum of stones of some piles was S, Pangu would need S seconds to pile them into one pile, and there would be S stones in the new pile.

Unfortunately, every time Pangu could only merge successive piles into one pile. And the number of piles he merged shouldn't be less than L or greater than R.

Pangu wanted to finish this as soon as possible.

Can you help him? If there was no solution, you should answer '0'.

Input

There are multiple test cases.

The first line of each case contains three integers N,L,R as above mentioned (2<=N<=100,2<=L<=R<=N).

The second line of each case contains N integers a1,a2 …aN (1<= ai  <=1000,i= 1…N ), indicating the number of stones of  pile 1, pile 2 …pile N.

The number of test cases is less than 110 and there are at most 5 test cases in which N >= 50.

Output

For each test case, you should output the minimum time(in seconds) Pangu had to take . If it was impossible for Pangu to do his job, you should output  0.

Sample Input

3 2 2
1 2 3
3 2 3
1 2 3
4 3 3
1 2 3 4

Sample Output

9
6
0

很明显的区间dp,但是和一般的区间dp有些区别。

因为有限制条件,每次只能操作[l,r]区间内的堆,开第三维来记录状态。

即 dp[i][j][k]表示把i到j合并成k堆的最小花费。

由题意可得

当k=1时,dp[i][j][1]=min(dp[i][j][k]+pre[j]-pre[i-1]),其中pre是前缀和

当k>1时,可枚举中点m,dp[i][j][k]=min(dp[i][m][k-1]+dp[m+1][j][1]) 因为并没有进行合并操作,所以不需要加上区间花费

#include "cstdio"
#include "cstring"
#include "queue"
#include "iostream"
#include "vector"
#include "algorithm"
#include "map"
using namespace std;
const int inf = 0x3f3f3f3f;
int a[104];
int dp[104][104][104];
int pre[104];
int main()
{
    int n,l,r;
    while(cin>>n>>l>>r)
    {
        memset(dp,inf, sizeof(dp));
        memset(pre,0, sizeof(pre));
        for (int i = 1; i <= n; ++i) {
            scanf("%d",&a[i]);
            pre[i]=pre[i-1]+a[i];
        }
        for (int len = 1; len <= n; ++len) {//长度为len的区间分为len堆没有代价
            for (int i = 1; i+len-1 <= n; ++i) {
                dp[i][i+len-1][len]=0;
            }
        }
        for (int len = 2; len <= n; ++len) {
            for (int i = 1; i+len-1 <= n; ++i) {
                int j=i+len-1;
                for (int k = 2; k <= len; ++k) {//k>1的情况,此处不用做k的限制
                    for (int m = i; m < j; ++m) {//枚举中点m,更新i,j区间
                        dp[i][j][k]=min(dp[i][j][k],dp[i][m][k-1]+dp[m+1][j][1]);
                    }
                }
                for (int k = l; k <= r; ++k) {//通过上面的状态转移,注意k的限制
                    dp[i][j][1]=min(dp[i][j][1],dp[i][j][k]+pre[j]-pre[i-1]);
                }
            }
        }
        printf("%d\n",dp[1][n][1]==inf?0:dp[1][n][1]);
    }
}

猜你喜欢

转载自blog.csdn.net/qq_42671946/article/details/86078600